package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: QueryType
// UnionValue: Url

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RequestByUrl")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RequestByUrl implements Marshallable {
	public final QueryType type = QueryType.URL;
	private Url url;
	private boolean scratch;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public RequestByUrl url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public RequestByUrl url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public boolean getScratch() {
	    return scratch;
	}
	public void setScratch(final boolean value) {
	    this.scratch = value;
	}

	public RequestByUrl scratch(final boolean value) {
	    setScratch(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(!this.scratch)) {
            marshaller.writeBool(3, this.scratch);
        }
        return marshaller.array();
    }
}
